'Application firmware 4.4.2 Changes:
'
' 1.  Force arming - It is no longer necessary to enter a user code twice when .force. arming. The system can be .force. armed
'     With one or more zones violated provide the zone(s) have all been enabled with the .force arm. option. This included interior
'     motion detectors which might happen to be aimed in the direction of a keypad location.
'-> 2.  Area Arming - New Zone definition #35 added - The main reason for this new zone def is to permit one of the keypad
'     Function keys to be assigned as a quick way to access the multi-area arming menu. A problem was also resolved which
'     prevented scrolling up or down on the area arm menu IF the entry or exit time were active.
' 3.  Low battery detect threshold voltage lowered from 12.0 volts to 11.7 volts. This helps eliminate a potential incident of a
'     false low battery trouble condition which was possible during brief periods of high current draw.
' 4.  Enrolling Bus Modules from ElkRP - All previously enrolled devices are now cleared prior to a new enrollment.
' 5.  ElkRM * Key - The panel now recognizes the pressing of the * key from ElkRM as a silence for keypad beeps.
' 6.  24 Hr. alarms - Resolved an issue having to do with display/activation of 24 Hr alarms above keypad address 7.
' 7.  Burg Interior Defined Zones - Resolved an issue whereby Interior Def. zone would follow the entry delay timer even if not
'     defined as .interior follower.. Interior zones must now be defined as Interior Follower if you want them to follow the delay.
' 8.  Serial Connection of ElkRP - Resolved issue which prevented a direct .serial. connection of ElkRP following a disconnect
'     from the modem connect method. This previously required a dialer report or power cycle to reset.
'-> 9.  ASCII String Arm/Disarm - Resolved issue of user code not being verified as valid in an area whenever an ASCII string
'     arm/disarm command issue.
' 10. Enable/disable Speech Rule - Resolved issue of telephone remote control not providing voice prompts if a rule was
'     issued to disable speech. A telephone remote control session will now override the disable speech rule.
' 11. Exit Error - Resolved exit error incorrectly getting set if a delay and instant zone were triggered at the end of entrance time.
'+> 12. User Codes - Codes have been increased from 99 to 199. The default code reported for Keyfob arm/disarm is now 199.
' 13. Output Names (Descriptions) - Outputs 33 to 64 may now have custom names programmed. Their default is Output #.
'     NOTE: The current release ELKRM and the M1XEP Web Keypad do not yet recognize these additional output names.
' 14. Lighting Dim Level Adjustment from keypad - Added capability to set the dim level in 10% increments (0-9) for most types
'     of dimming lights from the keypad automation lighting menu.
' 15. Prox Card Reading - Resolved issue that occasionally caused a prox card read to disallow subsequent reads until the *
'     key press was pressed.
' 16. Temperature Zone - Resolved an issue which allowed a temperature probe (zones 1 - 16) to make the ready light blink
'     whenever a keypad zone is programmed and violated.
' 17. Changed the way the serial port requests Tasks, Output, and Lights so that it now requires the first character to be greater
'     than a space in the name field and the show bit setting.
' 18. Rule trigger for 24hr alarm silence - Added the ability to fire a rule upon code entry following a 24hr alarm. (Disarming)
' 19. Phone Line Fault - Resolved issue which could falsely cause the dialer to report Phone Line Fault after firmware update.
' 20. Multiple logging of Entry/Exit Zones - Resolved issue which caused additional E/E zones to be falsely logged whenever an
'     alarm was caused by any entry/exit zone.
' 21. Day/Nite status for the rule engine gets set upon power up.


Option Explicit
'On Error Resume Next

Dim nit
Dim ReceivedData
Dim OldReceivedData
Dim Action
Dim PinCode
Dim PinStatus
Dim PinTimer
Dim Status
Dim strLine1
Dim strLine2
Dim OldstrLine1
Dim OldstrLine2
Dim arrZoneName(209)
Dim arrOutputname(209)
Dim arrUserName(200)
Dim arrKeypadName(17)
Dim arrZoneNrs
Dim arrOutputNrs
Dim MaxZones	       'Kind of Const, but defined as UBound(array)
Dim MaxOutputs	       'Kind of Const, but defined as UBound(array)
Dim StartDataCount
Dim AlarmZone          'Used in AlarmStatusReportData to buffer strLine2 in virtual keypad
Dim LastTrappedZone    'Last zone that trapped
Dim LastKeypadNr       'last keypad that was used
Dim LastUserCode       'Last user that used the keypad. Used for Logging combinations with Arming states etc. Get set in SendInvalidUserCodeDigits
Dim LastArmedStatus(9) 'Last arm state (8 Areas) used for detecting real changes in arming state to keep logging etc under control


'-------------------------------------------------------
'- Initialize ------------------------------------------
'-------------------------------------------------------
Const PinTimer_OffSet   = 10 'Seconds before timeout
Const MaxAreas          = 1  '<= 8
Const MaxUsers          = 6  '<= 99
Const MaxKeypads        = 2  '<= 16
Const MaxZoneSensors    = 0  '<= 16 Temperature Probe (See LW -> ReplyTemperatureData)
Const MaxThermostats    = 0  '<= ?? Used in ST -> TemperatureReportData
Const MaxStartDataCount = 24 'See Sub SetTextDescriptions for Count
Const DefaultstrLine2   = "DE REUSEL 1" 'Area Name displayed in virtual keypad
Const IntegrationArming = True 'Set this to false if IntegrationArming Sub is not to be executed
Const IntegrationKeys   = True 'Set this to false if IntegrationKeys Sub is not to be executed

arrZoneNrs      = Array("001", "002", "003", "004", "005", "006", "193", "194")
arrOutputNrs    = Array("001", "002", "003", "007")
MaxZones        = UBound(arrZoneNrs)
MaxOutputs      = UBound(arrOutputNrs)
StartDataCount  = 0
Status          = " "
PinCode         = ""
PinStatus       = ""
strLine1        = ""
strLine2        = ""
LastTrappedZone = ""
LastUserCode    = 0 'This value gets reset in AlarmStatusReportData
LastKeypadNr    = 0 'This value gets reset in AlarmStatusReportData
OldReceivedData = GetPropertyValue ("Alarm.Received Data")
SetpropertyValue "Alarm Status.Action", "Waiting"

For nit = 0 to MaxZones
	arrZoneName(nit) = arrZoneNrs(nit)
Next

arrUserName(0) = "Computer"
For nit = 1 to MaxUsers
	arrUserName(nit) = CStr(nit)
Next

arrKeypadName(0) = "Computer keypad"
For nit = 1 to MaxKeypads
	arrKeypadName(nit) = "keypad " & CStr(nit)
Next


'-------------------------------------------------------
'- Main: Checks Received Data and Handles Send Data ----
'-------------------------------------------------------
Do
	Sleep 1
	ReceivedData = GetPropertyValue ("Alarm.Received Data")
	If OldReceivedData <> ReceivedData Then
		OldReceivedData = ReceivedData
		Call Handle_ReceivedData(ReceivedData)
	End If

	If StartDataCount < MaxStartDataCount Then
		StartDataCount = StartDataCount + 1
		Call SetStartData(StartDataCount)
		Sleep 50 'When Raw Rx logging of start data fails, or misses log lines, increase Sleep value
	End If
	
	Action = GetPropertyValue ("Alarm Status.Action")
	If Action <> "Waiting" Then
		SetpropertyValue "Alarm Status.Action", "Waiting"
		Sleep 100
		If Action <> "" Then
			Call Handle_SendData(Action)
		End If
	End If
	
	If Len(PinCode) > 0 Then
		If Timer >= (86400 - PinTimer_OffSet) and PinTimer <= (86400 - PinTimer_OffSet) Then
			If PinTimer < (Timer - 86400 - PinTimer_OffSet) Then
				PinCode = ""
				Status = "PinCode TimeOut"
			End If
		Else
			If PinTimer < Timer Then
				PinCode = ""
				Status = "PinCode TimeOut"
			End If
		End If
	End If
	
	If Len(PinStatus) <> Len(PinCode) Then
		PinStatus = String(Len(PinCode), "*")
		strLine2  = R_Pad(PinStatus, 16, " ")
	End If
	
	If OldstrLine1 <> strLine1 Then
		OldstrLine1 = strLine1
		SetPropertyValue "Alarm Status.KeyPad Line1", strLine1
	End If

	If OldstrLine2 <> strLine2 Then
		OldstrLine2 = strLine2
		SetPropertyValue "Alarm Status.KeyPad Line2", strLine2
	End If
		
	If Status <> "" Then
		SetPropertyValue "Alarm Status.Status", Status
		Status = ""
	End If
Loop


'-------------------------------------------------------
Sub Handle_ReceivedData(Data)
Dim nit
Dim MessageStatus
Dim MessageData
Dim DataBytes

	MessageData = Split(Data, vbCRLF)
	For nit = 0 to (UBound(MessageData) - 1)
		DataBytes = VerifyLengthAndChecksum(MessageData(nit))
		'DataBytes can hold true bytes (Message - Length, Command and Checksum) or a Status like: Wrong Length or Wrong Checksum
		'Example: Message = 17 IC 0000030405060000100 CC -> DataBytes = 0000030405060000100
		If Left(DataBytes, 5) <> "Wrong" Then
			Select Case Mid(MessageData(nit), 3, 2)
				Case "AR": Call AlarmReportingToEthernet(DataBytes)
				Case "AS": Call AlarmStatusReportData(DataBytes)
				Case "AR": Call EthernetTestToIP(DataBytes)
				Case "AZ": Call AlarmByZoneReply(DataBytes)
				Case "CC": Call ControlOutputChangeUpdate(DataBytes)
				Case "CR": Call CustomValueReportData(DataBytes)
				Case "CS": Call ControlOutputStatusReportData(DataBytes)
				Case "CU": Call ChangeUserCodeReply(DataBytes)
				Case "DS": Call LightingPollResponse(DataBytes)
				Case "EM": Call EMailTriggerToM1XEP(DataBytes)
				Case "IC": Call SendInvalidUserCodeDigits(DataBytes)
				Case "IE": Call InstallerProgramExited(DataBytes)
				Case "KA": Call KeypadAreasReportData(DataBytes)
				Case "KC": Call KeypadKeyChangeUpdate(DataBytes)
				Case "KF": Call FunctionKeyPressedData(DataBytes)
				Case "LD": Call LogDataWithIndex(DataBytes)
				Case "LW": Call ReplyTemperatureData(DataBytes)
				Case "PC": Call PLCChangeUpdate(DataBytes)
				Case "PS": Call PLCStatusReportData(DataBytes)
				Case "RE": Call RequestEthernetModule(DataBytes)
				Case "RR": Call RealTimeClockData(DataBytes)
				Case "SD": Call TextStringDescriptionReportData(DataBytes)
				Case "ST": Call TemperatureReportData(DataBytes)
				Case "TC": Call TaskChangeUpdate(DataBytes)
				Case "TR": Call ThermostatDataReport(DataBytes)
				Case "UA": Call UserCodeAreasReportData(DataBytes)
				Case "XK": Call RequestEthernetTest(DataBytes)
				Case "ZB": Call ZoneBypassReportData(DataBytes)
				Case "ZC": Call ZoneChangeUpdate(DataBytes)
				Case "ZD": Call ZoneDefinitionReportData(DataBytes)
				Case "ZP": Call ZonePartitionReportData(DataBytes)
				Case "ZS": Call ZoneStatusReportData(DataBytes)
				Case "ZV": Call ZoneAnalogVoltageData(DataBytes)
				Case Else: Status = "Unknown Received Data: " & DataBytes
					   Call WriteLog("On", "!!! " & Status)
			End Select
			Call WriteLog(GetPropertyValue ("Alarm Status.Log Switch Raw Data"), "Raw Rx: " & MessageData(nit))
		Else
			Status = "Invalid Received Data: " & MessageData(nit) & " - Status: " & DataBytes 'DataBytes contains a status here
			Call WriteLog("On", "!!! " & Status)
		End If
	Next
End Sub


'-------------------------------------------------------
Sub Handle_SendData(Action)
Dim Data

	Data = Split(Action, "_") 'Typical Data "Key_0" or "TaskActivation_023" or "CtrlOutputOn_00300025" or "Status_KeypadAreas"
	Select Case Data(0)
		Case "Key"               : Call ProcessKeys(Data(1))		'K	  -> 0 - 9 or Clear
		Case "Arm"               : Call SetArming(Data(1))		'See Sub for CommandData
		Case "Status"            : Call RequestStatus(Data(1))		'See Sub for CommandData
		Case "CtrlOutputOn"      : Call ControlOutputOn(Data(1))	'ZZZTTTTT -> Zone 001-208, Secs 00000-65535
		Case "CtrlOutputOff"     : Call ControlOutputOff(Data(1))	'ZZZ	  -> Zone 001-208
		Case "CtrlOutputToggle"  : Call ControlOutputToggle(Data(1))	'ZZZ	  -> Zone 001-208
		Case "KeypadFunctionKey" : Call KeypadFunctionKey(Data(1))      'NND      -> Keypad 01-16, Key 1-6 * C 0
		Case "TaskActivation"    : Call TaskActivation(Data(1))	        'DDD      -> Task 001-032
		Case "TextDescription"   : Call RequestTextDescription(Data(1)) 'TTNNN    -> Type 00-17, Range 001-xxx
		Case "SystemLogData"     : Call RequestSystemLogData(Data(1))	'ddd      -> LogLine 001 - 511
		Case "KeypadFKeyIllum"   : Call RequestKeypadFKeyIllum(Data(1)) 'NN	  -> Keypad number
		Case "Temperature"       : Call RequestTemperature(Data(1))     'GNN      -> Group (0,1,2), Device (..)
		Case "Thermostat"        : Call RequestThermostat(Data(1))      'NN       -> Thermostat 01-16
		Case "ZoneVoltage"       : Call RequestZoneVoltage(Data(1))     'ZZZ	  -> Zone 001-208
		Case "DisplayText"       : Call DisplayText(Data(1))		'See Sub for CommandData
		Case "SpeakWord"         : Call SpeakWord(Data(1))              '1 23 231 -> Numbers of words from table separated by SPACE
		Case "SpeakPhrase"       : Call SpeakPhrase(Data(1))            '1 23 231 -> Numbers of phrases from table separated by SPACE
		Case "WriteRealTimeClock": Call WriteRealTimeClock(True)        'Flag     -> See Sub for info
		Case "SetStartData"      : StartDataCount = 0                   'Resets Count to run SetStartData routine in Main
		Case Else                : Status         = "Unknown Action Command " & Data(0)
					   Call WriteLog("On", "!!! " & Status)
	End Select
End Sub


'-------------------------------------------------------
'- Subs and Functions below are for Received Data ------
'-------------------------------------------------------
'- Verify length and checksum and return text result ---
'-------------------------------------------------------
Function VerifyLengthAndChecksum(Data)
Dim nit
Dim Checksum

	If Len(Data) >= 8 Then
		If Mid(Data, 1, 1) >= "0" and Mid(Data, 1, 1) <= "F" and Mid(Data, 2, 1) >= "0" and Mid(Data, 2, 1) <= "F" Then
			If CInt("&H" & Left(Data, 2)) = (Len(Data) - 2) Then
				Checksum = 0
				For nit = 1 to (Len(Data) - 2)
					checksum = checksum + Asc(Mid(Data, nit, 1))
				Next
        			
				If Right(Data, 2) = Right(Hex((checksum Xor 255) + 1), 2) Then
					VerifyLengthAndChecksum = Mid(Data, 5, Len(Data) - 6) 'Return only DataBytes without Length, Command and Checksum
				Else
					VerifyLengthAndChecksum = "Wrong Checksum"
				End If
			Else
				VerifyLengthAndChecksum = "Wrong Length (True length differs from Length Data)"
			End If
		Else
			VerifyLengthAndChecksum = "Wrong Length Data (Not a HEX value)"
		End If
	Else
		VerifyLengthAndChecksum = "Wrong Message (Too short, smaller than 8 bytes)"
	End If
End Function


'-------------------------------------------------------
'- AR --------------------------------------------------
'-------------------------------------------------------
Sub AlarmReportingToEthernet(Data)

	Status = "Not Supported: Alarm Reporting To Ethernet"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- AS --------------------------------------------------
'-------------------------------------------------------
Sub AlarmStatusReportData(Data)
Dim nit
Dim ArmedStatus(8)
Dim ArmUpState(8)
Dim AlarmState(8)
Dim AlarmTriggerFlag
Dim strLogLine
Dim UserName

	For nit = 1 to MaxAreas
		Select Case Mid(Data, nit, 1) 'ArmedStatus
			Case "0": ArmedStatus(nit) = "Disarmed" 	   	     : strLine1 = "READY TO ARM" '"Disarmed" is also used in ZoneChangeUpdate!!!
			Case "1": ArmedStatus(nit) = "Armed Away"	   	     : strLine1 = "ARMED AWAY"
			Case "2": ArmedStatus(nit) = "Armed Stay"	   	     : strLine1 = "ARMED STAY"
			Case "3": ArmedStatus(nit) = "Armed Stay Instant"  	     : strLine1 = "ARMED STAY INST"
			Case "4": ArmedStatus(nit) = "Armed Night"	   	     : strLine1 = "ARMED NIGHT"
			Case "5": ArmedStatus(nit) = "Armed Night Instant" 	     : strLine1 = "ARMED NIGHT INS"
			Case "6": ArmedStatus(nit) = "Armed Vacation"	   	     : strLine1 = "ARMED VACATION"
		End Select
		
		Select Case Mid(Data, (nit + 8), 1) 'ArmUpState
			Case "0": ArmUpState(nit) = "Not Ready To Arm"	   	     : strLine1 = "NOT READY x Zn"
			Case "1": ArmUpState(nit) = "Ready To Arm"	   	     : strLine2 = R_Pad(DefaultstrLine2, 16, " ")
			Case "2": ArmUpState(nit) = "Ready To Arm, Violated Zone!"   : strLine1 = "READY FORCE"
			Case "3": ArmUpState(nit) = "Armed with Exit Timer"          : strLine2 = R_Pad("EXIT TIME = xx", 16, " ")
			Case "4": ArmUpState(nit) = "Armed Fully"		     : strLine2 = R_Pad(DefaultstrLine2, 16, " ")
			Case "5": ArmUpState(nit) = "Force Armed with Violated Zone"
			Case "6": ArmUpState(nit) = "Armed with a bypass"
		End Select
		
		AlarmTriggerFlag = True
		Select Case Mid(Data, (nit + 16), 1) 'AlarmState
			Case "0": AlarmState(nit) = "No Alarm Active"		     : AlarmTriggerFlag = False
			Case "1": AlarmState(nit) = "Entrance Alarm Active"	     : AlarmTriggerFlag = False   : strLine2 = R_Pad("Entrance = xx", 16, " ")
			Case "2": AlarmState(nit) = "Alarm Abort Delay Active"       : AlarmTriggerFlag = False
			Case "3": AlarmState(nit) = "Fire Alarm"		     : strLine1 = "FIRE ALARM"    : strLine2 = AlarmZone
			Case "4": AlarmState(nit) = "Medical Alarm"                  : strLine1 = "MEDICAL ALARM"
			Case "5": AlarmState(nit) = "Police Alarm"                   : strLine1 = "POLICE ALARM"
			Case "6": AlarmState(nit) = "Burglar Alarm"		     : strLine1 = "BURGLAR ALARM" : strLine2 = AlarmZone
			Case "7": AlarmState(nit) = "Aux 1 Alarm"
			Case "8": AlarmState(nit) = "Aux 2 Alarm"
			Case "9": AlarmState(nit) = "Aux 3 Alarm"
			Case ":": AlarmState(nit) = "Aux 4 Alarm"
			Case ";": AlarmState(nit) = "Carbon Monoxide Alarm"	     : strLine1 = "CO ALARM"	  : strLine2 = AlarmZone
			Case "<": AlarmState(nit) = "Emergency Alarm"
			Case "=": AlarmState(nit) = "Freeze Alarm"		     : strLine1 = "FREEZE ALARM"  : strLine2 = AlarmZone
			Case ">": AlarmState(nit) = "Gas Alarm"			     : strLine1 = "GAS ALARM"	  : strLine2 = AlarmZone
			Case "?": AlarmState(nit) = "Heat Alarm"		     : strLine1 = "HEAT ALARM"    : strLine2 = AlarmZone
			Case "@": AlarmState(nit) = "Water Alarm"		     : strLine1 = "WATER ALARM"   : strLine2 = AlarmZone
			Case "A": AlarmState(nit) = "Fire Supervisory"
			Case "B": AlarmState(nit) = "Verify Fire"
		End Select 
        	
		SetPropertyValue "Alarm Status.Area " & nit & " Armed Status", ArmedStatus(nit)
		SetPropertyValue "Alarm Status.Area " & nit & " Arm Up State", ArmUpState(nit)
		SetPropertyValue "Alarm Status.Area " & nit & " Alarm State", AlarmState(nit)

		If LastArmedStatus(nit) <> ArmedStatus(nit) Then
			'Code below is only executed when the Arming state really changes. If a zone change (ZC) takes place, this Sub is executed
			' but since the arming state remains the same, no Integration_Arming will be done and logging will be different -> See Else
			LastArmedStatus(nit) = ArmedStatus(nit)
			UserName             = GetUsername()
			Status               = "User " & UserName & " " & ArmedStatus(nit) & " Area " & nit & " which is " & ArmUpState(nit) & " with " & AlarmState(nit) & " on " & arrKeypadName(LastKeypadNr)		
			Call WriteLog(GetPropertyValue ("Alarm Status.Log Switch Arming"), "Arming: " & Status)
			
			If IntegrationArming = True Then
				Call Integration_Arming(nit, ArmedStatus(nit)) 'nit = Area x
			End If
		Else
			Status = "System is " & ArmedStatus(nit) & " and " & ArmUpState(nit) & " with " & AlarmState(nit)
			Call WriteLog(GetPropertyValue ("Alarm Status.Log Switch Arming"), "Arming: " & Status)
		End If
		
		'This If changes strLine2 only when the AlarmState changes. The AlarmState changes according priority.
		'Example: If CO ALARM is followed by a FIRE ALARM, the new FIRE ALARM will be reported while NOT vise versa!
		'AlarmZone is needed to update strLine2 in the AlarmState Select Case above to overwrite the strLine2 set in the ArmUpState Cases
		If OldstrLine1 <> strLine1 Then
			Select Case strLine1
				Case "FIRE ALARM", "BURGLAR ALARM", "CO ALARM", "FREEZE ALARM", "GAS ALARM", "HEAT ALARM", "WATER ALARM":
					strLine2  = R_Pad(LastTrappedZone, 16, " ")
					AlarmZone = strLine2
			End Select
		End If
		
		'If Alarm is triggered >= FireAlarm and still Armed then an Alarm triggers LogLine is written -> See above @ AlarmState
		If AlarmTriggerFlag = True Then
			If ArmedStatus(nit) = "Disarmed" Then
				strLine2 = R_Pad(DefaultstrLine2, 16, " ")
			Else
				strLogLine = AlarmState(nit) & " originated in zone " & LastTrappedZone
				Call WriteLog(GetPropertyValue ("Alarm Status.Log Switch Alarm Triggers"), "Alarm triggers: " & strLogLine)
			End If
		End If
	Next
	
	Call RequestStatus("AlarmByZone") 'Update Zone xxx AlarmState
	LastKeypadNr = 0 'Reset LastKeypadNr here so next time the system Disarms via the PC, the SpeakWord sub is not called in Integration_Arming
	LastUserCode = 0 'See above. This is the last point after an event. After this Sub, the LastKeypadNr and LastUserCode are updated by the system again
End Sub


'-------------------------------------------------------
'- AT --------------------------------------------------
'-------------------------------------------------------
Sub EthernetTestToIP(Data)

	Status = "Not Supported: Ethernet Test To IP"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- AZ --------------------------------------------------
'-------------------------------------------------------
Sub AlarmByZoneReply(Data)
Dim nit
Dim AlarmState

	For nit = 0 to MaxZones
		Select Case Mid(Data, arrZoneNrs(nit), 1)
			Case "0" : AlarmState = "Disabled"
			Case "1" : AlarmState = "Burglar Entry/Exit 1"
			Case "2" : AlarmState = "Burglar Entry/Exit 2"
			Case "3" : AlarmState = "Burglar Perimeter Instant"
			Case "4" : AlarmState = "Burglar Interior"
			Case "5" : AlarmState = "Burglar Interior Follower"
			Case "6" : AlarmState = "Burglar Interior Night"
			Case "7" : AlarmState = "Burglar Interior Night Delay"
			Case "8" : AlarmState = "Burglar 24 Hour"
			Case "9" : AlarmState = "Burglar Box Tamper"
			Case ":" : AlarmState = "Fire Alarm"
			Case ";" : AlarmState = "Fire Verified"
			Case "<" : AlarmState = "Fire Supervisory"
			Case "=" : AlarmState = "Aux Alarm 1"
			Case ">" : AlarmState = "Aux Alarm 2"
			Case "?" : AlarmState = "Key fob"
			Case "@" : AlarmState = "Non Alarm"
			Case "A" : AlarmState = "Carbon Monoxide"
			Case "B" : AlarmState = "Emergency Alarm"
			Case "C" : AlarmState = "Freeze Alarm"
			Case "D" : AlarmState = "Gas Alarm"
			Case "E" : AlarmState = "Heat Alarm"
			Case "F" : AlarmState = "Medical Alarm"
			Case "G" : AlarmState = "Police Alarm"
			Case "H" : AlarmState = "Police No Indication"
			Case "I" : AlarmState = "Water Alarm"
			Case Else: AlarmState = "Unknown !!!"
		End Select
		
		SetPropertyValue "Alarm Status.Zone " & arrZoneNrs(nit) & " AlarmState", AlarmState
	Next
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch General"), "General: Zone AlarmState is updated")
End Sub


'-------------------------------------------------------
'- CC --------------------------------------------------
'- Data = ZZZS00 - ZZZ = OutputNr, S = output Status ---
'-------------------------------------------------------
Sub ControlOutputChangeUpdate(Data)
Dim nit
Dim OutputNr
Dim OutputState
	
	OutputNr = Left(Data, 3)

	For nit = 0 to MaxOutputs
		If OutputNr = arrOutputNrs(nit) Then
			Select Case CInt(Mid(Data, 4, 1))
				Case 0: OutputState = "Off"
				Case 1: OutputState = "On"
			End Select
			
			SetPropertyValue "Alarm Status.Output " & arrOutputNrs(nit), OutputState
			Call WriteLog(GetPropertyValue ("Alarm Status.Log Switch Outputs"), "Outputs: " & OutputNr & " " & arrOutputName(nit) & " is switched " & OutputState & " by PC")			
			Exit For
		End If
	Next
End Sub


'-------------------------------------------------------
'- CR --------------------------------------------------
'-------------------------------------------------------
Sub CustomValueReportData(Data)

	Status = "Not Supported: Custom Value Report Data"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- CS --------------------------------------------------
'- Data = DDDDDDD.....DDD (208 Bytes for 208 Outputs) --
'-------------------------------------------------------
Sub ControlOutputStatusReportData(Data)
Dim nit

	For nit = 0 to MaxOutputs
		'Data = ZZZS - ZZZ = OutputNr, S = Output Status
		Call ControlOutputChangeUpdate(arrOutputNrs(nit) & Mid(Data, CInt(arrOutputNrs(nit)), 1))
	Next
End Sub


'-------------------------------------------------------
'- CU --------------------------------------------------
'-------------------------------------------------------
Sub ChangeUserCodeReply(Data)

	Status = "Not Supported: Change user Code Reply"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- DS --------------------------------------------------
'-------------------------------------------------------
Sub LightingPollResponse(Data)

	Status = "Not Supported: Lightting Poll Response"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- EM --------------------------------------------------
'-------------------------------------------------------
Sub EMailTriggerToM1XEP(Data)

	Status = "Not Supported: EMail trigger To M1XEP"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- IC --------------------------------------------------
'- Data = DDDDDDDDDDDDUUUNN - D12 = Pincode, UUU = UserCode, NN = Keypad Nr
'-        00000304050600001 - Invalid Pincode 3456 @ keypad 01
'-        00000000000000301 - Valid Pincode for user 003 @ keypad 01
'-------------------------------------------------------
Sub SendInvalidUserCodeDigits(Data)
Dim PinCodeNr
Dim KeyPadNr

	'In plaats van Status hieronder een AlarmLog vullen. Deze data komt alleen wanneer via een keypad wordt ge-armed
	
	PinCodeNr    = Mid(Data, 6, 1) & Mid(Data, 8, 1) & Mid(Data, 10, 1) & Mid(Data, 12, 1) '4 Digits only!
	LastUserCode = CInt(Mid(Data, 13, 3)) 'This is where Global variable LastUserCode gets set
	KeyPadNr     = Mid(Data, 16, 2)

	If LastUserCode = 0 Then
		 Status = "InValid Pincode " & PinCodeNr & " entered on " & arrKeypadName(KeyPadNr)
		 Call WriteLog("On", "!!! " & Status)
	Else
		If Left(Data, 12) = "000000000000" Then
			Status = GetUserName() & " used " & arrKeypadName(KeyPadNr)
		Else
			Status = "Unknown data " & Data
		End If
		Call WriteLog(GetPropertyValue ("Alarm Status.Log Switch User"), "User: " & Status)
	End If
End Sub


'-------------------------------------------------------
'- IE --------------------------------------------------
'-------------------------------------------------------
Sub InstallerProgramExited(Data)

	Status = "Not Supported: Installer Program Exited"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub
	

'-------------------------------------------------------
'- KA --------------------------------------------------
'-------------------------------------------------------
Sub KeypadAreasReportData(Data)

	Status = "Not Supported: Keypad Areas Report Data"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- KC --------------------------------------------------
'- Data = NNDDLLLLLLCPPPPPPPP00 - NN = KeypadNr, DD = Key, L[6] = F-Keys Illum Status (Not handled yet!)
'-------------------------------------------------------
Sub KeypadKeyChangeUpdate(Data)
Dim KeypadNr
Dim IllumState
Dim KeypadKey

	KeypadNr = Left(Data, 2)
	Select Case Mid(Data, 3, 2)
		Case "00": KeypadKey = "No Key"
		Case "11": KeypadKey = "*"
		Case "12": KeypadKey = "#"
		Case "13": KeypadKey = "F1"
		Case "14": KeypadKey = "F2"
		Case "15": KeypadKey = "F3"
		Case "16": KeypadKey = "F4"
		Case "17": KeypadKey = "Stay"
		Case "18": KeypadKey = "Exit"
		Case "19": KeypadKey = "Chime"
		Case "20": KeypadKey = "Bypass"
		Case "21": KeypadKey = "ELK"
		Case "22": KeypadKey = "Down"
		Case "23": KeypadKey = "Up"
		Case "24": KeypadKey = "Right"
		Case "25": KeypadKey = "Left"
		Case "26": KeypadKey = "F6"
		Case "27": KeypadKey = "F5"
		Case "28": KeypadKey = "DateKeyMode"
		Case Else: KeypadKey = "Unknown Data"
	End Select
	
	LastKeypadNr = KeypadNr 'This is where Global variable LastKeypadNr gets set
	SetPropertyValue "Alarm Status.Keypad Key", KeypadNr & "_" & KeypadKey
	Call WriteLog(GetPropertyValue ("Alarm Status.Log Switch Keypad Keys"), "Keypad " & KeypadNr & " - " & KeypadKey & " pressed")
	If IntegrationKeys = True and KeypadKey <> "Unknown Data" Then
		Call Integration_Keys(KeypadNr, KeypadKey)
	End If
End Sub


'-------------------------------------------------------
'- KF --------------------------------------------------
'-------------------------------------------------------
Sub FunctionKeyPressedData(Data)

	Status = "Not Supported: Function Key pressed Data"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- LD --------------------------------------------------
'-------------------------------------------------------
Sub LogDataWithIndex(Data)
Dim strEvent
Dim Message
	
	strEvent = CheckLogEvent(Left(Data, 4))
	Message  = strEvent & " User/Zone: " & Mid(Data,5, 3) & " Area: " & Mid(Data, 8, 1)
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch ELK Log Data"), "ELK Log: " & Message)
End Sub


'-------------------------------------------------------
'- LW --------------------------------------------------
'-------------------------------------------------------
Sub ReplyTemperatureData(Data)
Dim nit

	For nit = 1 to MaxZoneSensors 'Group 0 = Probes
		Call TemperatureReportData("0" & L_Pad(nit, 2, "0") & Mid(Data, 48 + (nit * 3) - 2, 3)) '48 Is offset in Data where Probe Data begins
	Next
	
	For nit = 1 to MaxKeypads     'Group 1 = Keypads
		Call TemperatureReportData("1" & L_Pad(nit, 2, "0") & Mid(Data, (nit * 3) - 2, 3))	
	Next

End Sub


'-------------------------------------------------------
'- PC --------------------------------------------------
'-------------------------------------------------------
Sub PLCChangeUpdate(Data)

	Status = "Not Supported: PLC Change Update"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- PS --------------------------------------------------
'-------------------------------------------------------
Sub PLCStatusReportData(Data)

	Status = "Not Supported: PLC Status Report Data"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- RE --------------------------------------------------
'-------------------------------------------------------
Sub RequestEthernetModule(Data)

	Status = "Not Supported: Request Ethernet Module"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- RR --------------------------------------------------
'-------------------------------------------------------
Sub RealTimeClockData(Data)

	Status = "Not Supported: Real Time Clock Data"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- SD --------------------------------------------------
'-------------------------------------------------------
Sub TextStringDescriptionReportData(Data)
Dim nit
Dim strType
Dim strRange
Dim strTextDescription

	strType            = Left(Data, 2)
	strRange           = Mid(Data, 3, 3)
	strTextDescription = Mid(Data, 6, 16)
	
	Select Case strType
		Case "00": 'Zone Name
			For nit = 0 to MaxZones
				If strRange = arrZoneNrs(nit) Then
					arrZoneName(nit) = Trim(strTextDescription)
					Exit For
				End If
			Next
		Case "01": 'Area Name
		Case "02": 'User Name
			If CInt(strRange) <= MaxUsers Then
				arrUserName(CInt(strRange)) = Trim(strTextDescription)
			End If
		Case "03": 'Keypad Name
			If CInt(strRange) <= MaxKeypads Then
				arrKeypadName(CInt(strRange)) = Trim(strTextDescription)
			End If
		Case "04": 'Output Name
			For nit = 0 to MaxOutputs
				If strRange = arrOutputNrs(nit) Then
					arrOutputName(nit) = Trim(strTextDescription)
					Exit For
				End If
			Next
		Case Else: '05 - 17 -> Task, Telephone, Light, Alarm Duration, Custom Settings, Thermostat, Function Keys 1-6
			Call WriteLog("On", "!!! Unsupported Text String Description Request (4 - 17)")
	End Select
End Sub


'-------------------------------------------------------
'- ST --------------------------------------------------
'- Data = GNNDDD - G = Group, NN = Device, DDD = Temperature
'-------------------------------------------------------
Sub TemperatureReportData(Data)
Dim Group
Dim Device
Dim Temperature
Dim GroupName
Dim SetTempFlag

	SetTempFlag = False
	Group       = Left(Data, 1)
	Device      = Mid(Data, 2, 2)
	Temperature = CInt(Mid(Data, 4, 3))
	
	Select Case Group
		Case "0": GroupName   = "Probe "
			  Temperature = Temperature - 60
			  If CInt(Device) <= MaxZoneSensors Then
			  	SetTempFlag = True
			  End If
		Case "1": GroupName   = "Keypad "
			  Temperature = Temperature - 40
			  If CInt(Device) <= MaxKeypads Then
			  	SetTempFlag = True
			  End If
		Case "2": GroupName = "Thermostat "
			  If CInt(Device) <= MaxThermostats Then
			  	SetTempFlag = True
			  End If
	End Select
	
	If SetTempFlag = True Then
		SetPropertyValue "Alarm Status." & GroupName & Device & " Temp", Temperature
		Status = " "
		Call WriteLog(GetPropertyValue ("Alarm Status.Log Switch General"), "General: " & GroupName & Device & " temperature reads " & Temperature & " C")
	Else
		Status = "Out of range Temperature request for device. Probes: " & MaxZoneSensors & " - Keypads: " & MaxKeypads & " - Thermostats: " & MaxThermostats
	End If
End Sub


'-------------------------------------------------------
'- TC --------------------------------------------------
'-------------------------------------------------------
Sub TaskChangeUpdate(Data)

	Status = "Not Supported: Task Change Update"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- TR --------------------------------------------------
'-------------------------------------------------------
Sub ThermostatDataReport(Data)

	Status = "Not Supported: Thermostat Data Report"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- UA --------------------------------------------------
'-------------------------------------------------------
Sub UserCodeAreasReportData(Data)

	Status = "Not Supported: User Code Areas Report Data"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- XK --------------------------------------------------
'-------------------------------------------------------
Sub RequestEthernetTest(Data)
Dim ClockData
Dim WriteFlag

	WriteFlag = False
	ClockData = WriteRealTimeClock(False)
	If Mid(Data, 7, 7) <> Mid(ClockData, 7, 7) Then
		WriteFlag = True
	Else
		If Abs(DateDiff("n", TimeSerial(Mid(Data, 5, 2), Mid(Data, 3, 2), Left(Data, 2)), TimeSerial(Mid(ClockData, 5, 2), Mid(ClockData, 3, 2), Left(ClockData,2)))) > 2 Then
			WriteFlag = True
		End If
	End If
		
	If WriteFlag = True Then
		Call WriteRealTimeClock(True)
		Status = "ELK Clock Data out of sync. Clock is adjusted by PC"
		Call Writelog(GetPropertyValue ("Alarm Status.Log Switch General"), "General: " & Status)
	End If
End Sub


'-------------------------------------------------------
'- ZB --------------------------------------------------
'-------------------------------------------------------
Sub ZoneBypassReportData(Data)

	Status = "Not Supported: Zone Bypass Report Data"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- ZC --------------------------------------------------
'- Data = ZZZS00 - ZZZ = ZoneNr, S = Zone Status -------
'-------------------------------------------------------
Sub ZoneChangeUpdate(Data)
Dim nit
Dim ZoneNr
Dim ZoneStatus

	ZoneNr = Left(Data, 3)
	Select Case Mid(Data, 4, 1)
		Case "0" : ZoneStatus = "Normal Unconfigured"
		Case "1" : ZoneStatus = "Normal Open"
		Case "2" : ZoneStatus = "Normal EOL"
		Case "3" : ZoneStatus = "Normal Short"
		Case "4" : ZoneStatus = "not used"
		Case "5" : ZoneStatus = "Trouble Open"
		Case "6" : ZoneStatus = "Trouble EOL"
		Case "7" : ZoneStatus = "Trouble Short"
		Case "8" : ZoneStatus = "not used"
		Case "9" : ZoneStatus = "Violated Open"
		Case "A" : ZoneStatus = "Violated EOL"
		Case "B" : ZoneStatus = "Violated Short"
		Case "C" : ZoneStatus = "not used"
		Case "D" : ZoneStatus = "Bypassed Open"
		Case "E" : ZoneStatus = "Bypassed EOL"
		Case "F" : ZoneStatus = "Bypassed Short"
		Case Else: ZoneStatus = "Unknown Data"
	End Select
	
	For nit = 0 to MaxZones
		If ZoneNr = arrZoneNrs(nit) Then
			SetPropertyValue "Alarm Status.Zone " & arrZoneNrs(nit), ZoneStatus
			LastTrappedZone = arrZoneName(nit) 'Global variable used for strLine2 in Sub AlarmStatusReportData
			
			If GetPropertyValue ("Alarm Status.Log Switch Sensors WA") = "On" and GetPropertyValue ("Alarm Status.Area 1 Armed Status") <> "Disarmed" Then
				Call WriteLog("On", "Sensors WA: Zone " & arrZoneNrs(nit) & " " & arrZoneName(nit) & " - " & ZoneStatus)
			Else
				If GetPropertyValue ("Alarm Status.Log Switch Sensors") = "On" Then
					Call WriteLog("On", "Sensors: Zone " & arrZoneNrs(nit) & " " & arrZoneName(nit) & " - " & ZoneStatus)
				End If
			End If
			Exit For
		End If
	Next
End Sub


'-------------------------------------------------------
'- ZD --------------------------------------------------
'-------------------------------------------------------
Sub ZoneDefinitionReportData(Data)

	Status = "Not Supported: Zone Definition Report Data"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- ZP --------------------------------------------------
'-------------------------------------------------------
Sub ZonePartitionReportData(Data)

	Status = "Not Supported: Zone Partition Report Data"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- ZS --------------------------------------------------
'- Data = DDDDD.....DDD (208 Bytes for 208 Zones) ------
'-------------------------------------------------------
Sub ZoneStatusReportData(Data)           
Dim nit

	For nit = 0 to MaxZones
		'Data = ZZZS - ZZZ = ZoneNr, S = Zone Status
		Call ZoneChangeUpdate(arrZoneNrs(nit) & Mid(Data, CInt(arrZoneNrs(nit)), 1))
	Next
End Sub


'-------------------------------------------------------
'- ZV --------------------------------------------------
'-------------------------------------------------------
Sub ZoneAnalogVoltageData(Data)

	Status = "Not Supported: Zone Analog Voltage Data"
	Call Writelog(GetPropertyValue ("Alarm Status.Log Switch Unsupported"), Status)
End Sub


'-------------------------------------------------------
'- Subs and Functions below are for Sending Data -------
'-------------------------------------------------------
'- Process KeyPad Data ---------------------------------
'-------------------------------------------------------
Sub ProcessKeys(Data)

	If Data = "*" Then
		If Len(PinCode) > 0 Then
			PinCode = ""
		End If
		
		Exit Sub
	End If
		
	If Len(PinCode) >= 0 and Len(PinCode) < 4 and Data <> "Clear" Then
		PinCode = PinCode & Data
		Call SetPinTimer()
	End If
	
	If Len(PinCode) = 4 Then
		Status = "Valid PinCode -> Select Arming Mode"
	End If
End Sub


'-------------------------------------------------------
'- Data = Area|ArmingMode or ArmingMode ----------------
'- Examples: 1|DisArm or 2|Away or Night ---------------
'-------------------------------------------------------
Sub SetArming(Data)
Dim ArmingData
Dim Area
Dim ArmingMode
Dim MessageData

	Area       = 1
	ArmingMode = Data 'Default here in case Data = ArmingMode without an Area
	
	If Len(PinCode) = 4 Then
		ArmingData = Split(Data, "|")
		If UBound(ArmingData) = 1 Then
			Area       = ArmingData(0)
			ArmingMode = ArmingData(1)
		End If
		'MessageData = MMAPPPPPP - MM = Arm mode, A = Area, P = Pin
		Select Case ArmingMode
			Case "DisArm"          : MessageData = "a0" : Status = "System DisArming"
			Case "Away"            : MessageData = "a1" : Status = "System Arming Away"
			Case "Stay"            : MessageData = "a2" : Status = "System Arming to Stay"
			Case "StayInstant"     : MessageData = "a3" : Status = "System Arming to Stay Instant"
			Case "Night"           : MessageData = "a4" : Status = "System Arming to Night"
			Case "NightInstant"    : MessageData = "a5" : Status = "System Arming to Night Instant"
			Case "Vacation"        : MessageData = "a6" : Status = "System Arming to Vacation"
			Case "StepNextAwayMode": MessageData = "a7" : Status = "System Arming to Next Away Mode"
			Case "StepNextStayMode": MessageData = "a8" : Status = "System Arming to Next Stay Mode"
			Case Else              : MessageData = ""   : Status = "Unknown Arming Command"
		End Select
			
		If MessageData <> "" Then
			MessageData = MessageData & Area & "00" & PinCode 'Two leading zero's for a 4 digit PinCode
			SetPropertyValue "Alarm.Send Data", CreateValidMessage(MessageData)
			Call SetPinTimer()
		End If
	Else
		Status = "No Valid PinCode for Arming"
	End If
End Sub


'-------------------------------------------------------
'- See below for protocol codes ------------------------
'-------------------------------------------------------
Sub RequestStatus(Data)
Dim MessageData

	Select Case Data
		Case "Arming"             : MessageData = "as"
		Case "AlarmByZone"        : MessageData = "az"
		Case "Zone"               : MessageData = "zs"
		Case "ZoneDefinition"     : MessageData = "zd"
		Case "ZonePartition"      : MessageData = "zp"
		Case "ControlOutput"      : MessageData = "cs"
		Case "KeypadAreas"        : MessageData = "ka"
		Case "Temperatures"       : MessageData = "lw"
		Case "RealTimeClockData"  : MessageData = "rr"
		Case "ReadAllCustomValues": MessageData = "cp"
		Case Else                 : MessageData = ""
					    Status      = "Unknown Status Request"
	End Select
	
	If MessageData <> "" Then
		SetpropertyValue "Alarm.Send Data", CreateValidMessage(MessageData)
	End If
End Sub


'-------------------------------------------------------
'- cn --------------------------------------------------
'-------------------------------------------------------
Sub ControlOutputOn(Data)
Dim Output
Dim Seconds
Dim StateText

	If Len(Data) = 8 Then
		'Onderstaande splitsing is gemaakt om later betere error checking te verzorgen. Anders is 'Data' op zich al goed
		Output  = Left(Data, 3)  'Output line     (3 Digits -> 001 - 208)
		Seconds = Right(Data, 5) 'Time in seconds (5 Digits -> 00000 - 65535)
		SetPropertyValue "Alarm.Send Data", CreateValidmessage("cn" & Output & Seconds)
	Else
		Status = "Invalid Control Output On Data"
	End If
End Sub


'-------------------------------------------------------
'- cf --------------------------------------------------
'-------------------------------------------------------
Sub ControlOutputOff(Data)

	If Len(Data) = 3 and CInt(Data) >= 1 and CInt(Data) <= 208 Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("cf" & Data) '3 Digits 001 - 208
	Else
		Status = "Invalid Control Output Off Data"
	End If
End Sub


'-------------------------------------------------------
'- ct --------------------------------------------------
'-------------------------------------------------------
Sub ControlOutputToggle(Data)

	If Len(Data) = 3 and CInt(Data) >= 1 and CInt(Data) <= 208 Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("ct" & Data) '3 Digits 001 - 208
	Else
		Status = "Invalid Control Output Toggle Data"
	End If
End Sub


'-------------------------------------------------------
'- kf --------------------------------------------------
'- Data = 3 Digits. NND --------------------------------
'- NN   = Keypad 01 - 16 -------------------------------
'- D    = Function Key: 1 - 6, * = Silence trouble beep, C = Chime, 0 = Return KF command
'-------------------------------------------------------
Sub KeypadFunctionKey(Data)

	If Len(Data) = 3 Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("kf" & Data)
	Else
		Status = "Invalid Keypad Function Key Simulation"
	End If
End Sub


'-------------------------------------------------------
'- tn --------------------------------------------------
'-------------------------------------------------------
Sub TaskActivation(Data)

	If Len(Data) = 3 and CInt(Data) >= 1 and CInt(Data) <= 32 Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("tn" & Data) '3 Digits 001 - 032
	Else
		Status = "Invalid Task Activation Data"
	End If
End Sub


'-------------------------------------------------------
'- sd --------------------------------------------------
'- Data = 5 Digits. TTNNN ------------------------------
'- TT   = Type 00-17 - 00 = ZoneName, 02 = UserName etc
'- NNN  = Range 001-xxx --------------------------------
'- Example: 02003 = Get UserName of User Nr 003 --------
'-------------------------------------------------------
Sub RequestTextDescription(Data)

	If Len(Data) = 5 Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("sd" & Data)
	Else
		Status = "Invalid ASCII String Text Description Request"
	End If

End Sub


'-------------------------------------------------------
'- ld --------------------------------------------------
'-------------------------------------------------------
Sub RequestSystemLogData(Data)

	If Len(Data) = 3 and CInt(Data) >= 1 and CInt(Data) <= 511 Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("ld" & Data) '3 Digits 001 - 511
	Else
		Status = "Invalid System log Data Request"
	End If
End Sub


'-------------------------------------------------------
'- kc --------------------------------------------------
'-------------------------------------------------------
Sub RequestKeypadFKeyIllum(Data)

	If Len(Data) = 2 Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("kc" & Data) '2 Digits 01 - ??
	Else
		Status = "Invalid Keypad Function Key Illumination Request"
	End If
End Sub


'-------------------------------------------------------
'- st --------------------------------------------------
'- Data = 3 Digits. GNN --------------------------------
'- G  = Group: 0 = Probe, 1 = Keypad, 2 = Thermostat ---
'- NN = Device in the group. 2 ASCII Digits ------------
'-------------------------------------------------------
Sub RequestTemperature(Data)

	If Len(Data) = 3 Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("st" & Data)
	Else
		Status = "Invalid Temperature Request"
	End If
End Sub


'-------------------------------------------------------
'- tr --------------------------------------------------
'-------------------------------------------------------
Sub RequestThermostat(Data)

	If Len(Data) = 2 and CInt(Data) >= 1 and CInt(Data) <= 16 Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("tr" & Data) 'NN = Thermostat. 01-16
	Else
		Status = "Invalid Thermostat Data Request"
	End If
End Sub


'-------------------------------------------------------
'- zv --------------------------------------------------
'-------------------------------------------------------
Sub RequestZoneVoltage(Data)

	If Len(Data) = 3 and CInt(Data) >= 1 and CInt(Data) <= 208 Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("zv" & Data) '3 Digits 001 - 208
	Else
		Status = "Invalid Zone Voltage Request"
	End If
End Sub


'-------------------------------------------------------
'- dm --------------------------------------------------
'- Data  = 11100005abc^defg ----------------------------
'- 	   ACBTTTTTL1 SL2 ------------------------------
'- A     = Keypad Area 1 - 8 ---------------------------
'- C     = Clear -> 0 = Clr, 1 = Clr with * key, 2 = Display till timeout
'- B     = Beep  -> 0 = No Beep, 1 = Beep --------------
'- TTTTT = Timeout in seconds from 00001 - 65535 -------
'- L1    = Line 1 Displayed in bottom line of keypad. (Max 16 characters) and always followed by ^
'- S     = ^ used as separator -------------------------
'- L2    = Line 2 Displayped in bottom line of keypad. Displayed after Line 1 (Max 16 characters)
'-------------------------------------------------------
Sub DisplayText(Data)
Dim nit
Dim TextData

	Status   = " "
	TextData = Split(Right(Data, (Len(Data) - 8)), "^")
	Select Case UBound(TextData)
		Case 0: If Len(TextData(0)) < 16 Then
				TextData(0) = TextData(0) & "^" & String(15 - Len(TextData(0)) , "*")
			End If
			SetPropertyValue "Alarm.Send Data", CreateValidMessage("dm" & Left(Data, 8) & TextData(0) & "^")
		Case 1:	For nit = 0 to 1
				If Len(TextData(nit)) < 16 Then
					TextData(nit) = TextData(nit) & "^" & String(15 - Len(TextData(nit)), "*")
				End If
			Next
			SetPropertyValue "Alarm.Send Data", CreateValidMessage("dm" & Left(Data, 8) & TextData(0) & TextData(1))		
		Case Else: Status = "Invalid Display Text Data"
	End Select
End Sub


'-------------------------------------------------------
'- sw --------------------------------------------------
'- See manual chapter 5.0 Word and Phrase Table --------
'- Case Insensitive, Space separated, unknown words are disregarded
'- Example: SpeakWord_Oh oh you are in trouble ---------
'-------------------------------------------------------
Sub SpeakWord(Data)
Dim dicWordList
Dim FSO
Dim objStream
Dim arrWordLines
Dim nit
Dim arrLinepart
Dim arrWords
Dim intWordNr
	
	Set dicWordList = CreateObject("Scripting.Dictionary")
	Set FSO         = CreateObject("Scripting.FileSystemObject")
	Set objStream   = FSO.OpenTextFile("C:\Program Files\Meedio\Meedio HouseBot\Config\Scripts\ELK_Words.txt")
	arrWordLines    = split(LCase(objStream.ReadAll), VbCrLf)

	For nit = 0 To UBound(arrWordLines)
		If arrWordLines(nit) <> "" Then
			arrLinePart                 = split(arrWordLines(nit), " ")
			dicWordList(arrLinePart(1)) = arrLinePart(0)
			Erase arrLinePart
		End If
	Next
	
	Erase arrWordLines
	arrWords = Split(LCase(Data), " ")

	For nit = 0 To UBound(arrWords)
		If dicWordList.Exists(arrWords(nit)) Then
			SetPropertyValue "Alarm.Send Data", CreateValidMessage("sw" & L_Pad(dicWordList(arrWords(nit)), 3, "0"))
		End If
	Next
	
	Erase arrWords
	dicWordList.RemoveAll
	Set objStream   = Nothing
	Set FSO         = Nothing
	Set dicWordList = Nothing	
End Sub


'-------------------------------------------------------
'- sp --------------------------------------------------
'- See manual chapter 5.0 Word and Phrase Table --------
'- Example: SpeakPhrase_232 or SpeakPhrase_1 -----------
'-------------------------------------------------------
Sub SpeakPhrase(Data)
Dim nit
Dim Phrases

	Phrases = Split(Data, " ")

	For nit = 0 to UBound(Phrases)
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("sp" & L_Pad(Phrases(nit), 3, "0"))
	Next
End Sub


'-------------------------------------------------------
'- rw --------------------------------------------------
'- Always formatted to Now. Write the clock or compare -
'- Return data with XK Ethernet Module data ------------
'-------------------------------------------------------
Function WriteRealTimeClock(WriteFlag)
Dim MessageData

	MessageData = L_Pad(Second(Now), 2, "0") & L_Pad(Minute(Now), 2, "0") & L_Pad(Hour(Now), 2, "0") & Weekday(Date) & _
		      L_Pad(Day(Date), 2, "0")   & L_Pad(Month(Now), 2, "0")  & Right(Year(Now), 2)
	If WriteFlag = True Then
		SetPropertyValue "Alarm.Send Data", CreateValidMessage("rw" & MessageData)
		Status = "Writing Real Time Clock"
	Else
		WriteRealTimeClock = MessageData
	End If
End Function


'-------------------------------------------------------
'- Create valid message for send. Data excl Len & CS ---
'-------------------------------------------------------
Function CreateValidMessage(Data)
Dim nit
Dim MessageLength
Dim MessageData
Dim MessageChecksum

	'Two extra (future use) zero's (00) are added to each message extending the length with two characters
	'This means we origionally check for less then 16 (0xF) and add a leading zero to get two hex bytes (0x0F)
	'Now we check for 16 - the two zero's = 14 for it to work properly
	If Len(Data) < 14 Then
		MessageLength = "0" & Hex(Len(Data) + 4)
	Else
		MessageLength = CStr(Hex(Len(Data) + 4))
	End If
	
	MessageData     = MessageLength & Data & "00"
	MessageChecksum = 0
	For nit = 1 to Len(MessageData)
		MessageChecksum = MessageChecksum + Asc(Mid(MessageData, nit, 1))
	Next
        	
	MessageData        = MessageData & Right(Hex((MessageChecksum Xor 255) + 1), 2)
	CreateValidMessage = MessageData
	Call WriteLog(GetPropertyValue ("Alarm Status.Log Switch Raw Data"), "Raw Tx: " & MessageData)
End Function


'-------------------------------------------------------
'- Commonly used Subs and Functions for Main Script ----
'-------------------------------------------------------
'- Re/Set Global variable PinTimer for PinCode timeout -
'-------------------------------------------------------
Sub SetPinTimer()
	If Timer >= (86400 - PinTimer_OffSet) Then
		PinTimer = Timer - (86400 - PinTimer_OffSet) + PinTimer_OffSet
	Else
		PinTimer = Timer + PinTimer_OffSet
	End If
End Sub


'-------------------------------------------------------
'- Write Log Line --------------------------------------
'-------------------------------------------------------
Sub WriteLog(strLogFlag, strLogLine)
Dim FileSystem
Dim StdOut
Dim FileName
Dim AlarmLog
Dim LogLines
Dim LogCount
Dim nit

	On Error Resume Next
	If strLogFlag = "On" Then

		AlarmLog = GetPropertyValue ("Alarm Status.Log")

		If AlarmLog = "Geen items aanwezig" Then
			AlarmLog = ""
		End If

		LogLines = Split(AlarmLog, vbLF)
		LogCount = UBound(LogLines)
		AlarmLog = "*S-" & vbTAB & GetPropertyValue ("System Time.TimeAndDate") & "  " & strLogLine

		If LogCount > 50 Then
			LogCount = 50
		End If
		
		For nit = 0 to LogCount
			LogLines(nit) = Replace(LogLines(nit), "*S-", "")
			AlarmLog      = AlarmLog & vbLF & LogLines(nit)
		Next

		SetPropertyValue "Alarm Status.Log", AlarmLog
		Sleep 100 'Keep this Sleep here to prevent LogLines to be overwritten because of delay between HouseBot and script

		If GetPropertyValue ("Alarm Status.Log Switch File") = "On" Then
			FileName       = GetPropertyValue ("Alarm Status.Log File Path")
			Set FileSystem = CreateObject("Scripting.FileSystemObject")	
			Set StdOut     = FileSystem.OpenTextFile(FileName, 8, True)
                	
			If Err.Number = 0 Then
				StdOut.Write Date & " - " & Time & " - " & strLogLine & vbCRLF
				StdOut.Close
			Else
				Status = Err.Description
				Err.Clear
			End If
                	
			Set StdOut     = Nothing
			Set FileSystem = Nothing
		End If
	End If
	strLogLine = ""

End Sub


'-------------------------------------------------------
'- Format Data (Hour, Zones etc) to include leading 0's 
'-------------------------------------------------------
Function L_Pad(Data, Length, Char)

	L_Pad = String(Length - Len(Data), Char) & Data
End Function


'-------------------------------------------------------
'- Format Data (strLine2 etc) to include trailing 0's --
'-------------------------------------------------------
Function R_Pad(Data, Length, Char)

	R_Pad = Data & String(Length - Len(Data), Char)
End Function


'-------------------------------------------------------
'- GetUserName sets Name according to array or predefined
'-------------------------------------------------------
Function GetUserName()
	Select Case True
		Case LastUserCode >= 0 and LastUserCode <= MaxUsers: GetUserName = arrUserName(LastUserCode)
		Case LastUserCode = 101				   : GetUserName = "Installer"
		Case LastUserCode = 102				   : GetUserName = "ElkRP"
		Case LastUserCode = 103				   : GetUserName = "No Code"
		Case Else					   : GetUserName = CStr(LastUserCode)
	End Select
End Function


'-------------------------------------------------------
'- Check if Event Nr has a text. If not return Nr ------
'-------------------------------------------------------
Function CheckLogEvent(EventNr)

	Select Case CInt(EventNr)
		Case 1001: CheckLogEvent = "Fire Alarm"
		Case 1002: CheckLogEvent = "Fire Supervisory Alarm"
		Case 1003: CheckLogEvent = "Burglar Alarm, Any Area"
		Case 1004: CheckLogEvent = "Medical Alarm, Any Area"
		Case 1005: CheckLogEvent = "Police Alarm, Any Area"
		Case 1006: CheckLogEvent = "AUX 1 24 Hr Alarm, Any Area"
		Case 1007: CheckLogEvent = "AUX 2 24 Hr Alarm, Any Area"
		Case 1008: CheckLogEvent = "Carbon Monoxide Alarm, Any Area"
		Case 1009: CheckLogEvent = "Emergency Alarm, Any Area"
		Case 1010: CheckLogEvent = "Freeze Alarm, Any Area"
		Case 1011: CheckLogEvent = "Gas Alarm, Any Area"
		Case 1012: CheckLogEvent = "Heat Alarm, Any Area"
		Case 1013: CheckLogEvent = "Water Alarm, Any Area"
		Case 1014: CheckLogEvent = "Alarm, Any Area"
		Case 1015: CheckLogEvent = "Burglar Alarm in Area 1"
		Case 1023: CheckLogEvent = "Medical Alarm in Area 1"
		Case 1031: CheckLogEvent = "Police Alarm in Area 1"
		Case 1039: CheckLogEvent = "AUX 1 24 Hr in Area 1"
		Case 1047: CheckLogEvent = "AUX 2 24 Hr in Area 1"
		Case 1055: CheckLogEvent = "CO Alarm in Area 1"
		Case 1063: CheckLogEvent = "Emergency Alarm in Area 1"
		Case 1071: CheckLogEvent = "Freeze Alarm in Area 1"
		Case 1079: CheckLogEvent = "Gas Alarm in Area 1"
		Case 1087: CheckLogEvent = "Heat Alarm in Area 1"
		Case 1095: CheckLogEvent = "Water Alarm in Area 1"
		Case 1103: CheckLogEvent = "Any Alarm in Area 1"
		Case 1111: CheckLogEvent = "Code Lockout, Any Keypad"
		case 1112: CheckLogEvent = "Keypad 01 Code Lockout"
		case 1113: CheckLogEvent = "Keypad 02 Code Lockout"
		Case 1128: CheckLogEvent = "Fire Trouble, Any Zone"
		Case 1129: CheckLogEvent = "Burglar Trouble, Any Zone"
		Case 1130: CheckLogEvent = "Fail to Communicate Trouble"
		Case 1131: CheckLogEvent = "RF Sensor Low Battery Trouble"
		Case 1132: CheckLogEvent = "Lost ANC Module Trouble"
		Case 1133: CheckLogEvent = "Lost Keypad Trouble"
		Case 1134: CheckLogEvent = "Lost Input Expander Trouble"
		Case 1135: CheckLogEvent = "Lost Output Expander Trouble"
		Case 1136: CheckLogEvent = "EEPROM Memory Error Trouble"
		Case 1137: CheckLogEvent = "Flash Memory Error Trouble"
		Case 1138: CheckLogEvent = "AC Failure Trouble"			: strLine2 = "AC FAILURE"
		Case 1139: CheckLogEvent = "Control Low Battery Trouble"	: strLine2 = "LOW BATTERY"
		Case 1140: CheckLogEvent = "Control Overcurrent Trouble"
		Case 1141: CheckLogEvent = "Expansion Module Trouble"
		Case 1142: CheckLogEvent = "Output 2 Supervisory Trouble"
		Case 1143: CheckLogEvent = "Telephone Line Fault Trouble"
		Case 1144: CheckLogEvent = "Restore Fire Zone"
		Case 1145: CheckLogEvent = "Restore Fire Supervisory Zone"
		Case 1146: CheckLogEvent = "Restore Burglar Zone"
		Case 1147: CheckLogEvent = "Restore Medical Zone"
		Case 1148: CheckLogEvent = "Restore Police Zone"
		Case 1149: CheckLogEvent = "Restore AUX 1 24 Hr Zone"
		Case 1150: CheckLogEvent = "Restore AUX 2 24 Hr Zone"
		Case 1151: CheckLogEvent = "Restore CO Zone"
		Case 1152: CheckLogEvent = "Restore Emergency Zone"
		Case 1153: CheckLogEvent = "Restore Freeze Zone"
		Case 1154: CheckLogEvent = "Restore Gas Zone"
		Case 1155: CheckLogEvent = "Restore Heat Zone"
		Case 1156: CheckLogEvent = "Restore Water Zone"
		Case 1157: CheckLogEvent = "Communication Fail Restore"
		Case 1158: CheckLogEvent = "AC Fail Restore"			: strLine2 = R_Pad(DefaultstrLine2, 16, " ")
		Case 1159: CheckLogEvent = "Low Battery Restore"		: strLine2 = R_Pad(DefaultstrLine2, 16, " ")
		Case 1160: CheckLogEvent = "Control Overcurrent Restore"
		Case 1161: CheckLogEvent = "Expansion Module Restore"
		Case 1162: CheckLogEvent = "Ouput 2 Restore"
		Case 1163: CheckLogEvent = "Telephone Line Restore"
		Case 1164: CheckLogEvent = "Alarm memory, Any Area"
		Case 1165: CheckLogEvent = "Alarm memory, Area 1"
		Case 1173: CheckLogEvent = "Area Armed"
		Case 1174: CheckLogEvent = "Area Disarmed"
		Case 1175: CheckLogEvent = "Area 1 Arm State"
		Case 1183: CheckLogEvent = "Area 1 is Armed Away"
		Case 1191: CheckLogEvent = "Area 1 is Armed Stay"
		Case 1199: CheckLogEvent = "Area 1 is Armed Stay Instant"
		Case 1207: CheckLogEvent = "Area 1 is Armed Night"
		Case 1215: CheckLogEvent = "Area 1 is Armed Night Instant"
		Case 1223: CheckLogEvent = "Area 1 is Armed Vacation"
		Case 1231: CheckLogEvent = "Area 1 is Force Armed"
		Case 1239: CheckLogEvent = "Zone Bypassed"
		Case 1240: CheckLogEvent = "Zone Unbypassed"
		Case 1241: CheckLogEvent = "Any Burglar Zone is Faulted"
		Case 1242: CheckLogEvent = "Burglar Status of All Areas"
		Case 1243: CheckLogEvent = "Area 1 Burglar Status"
		Case 1251: CheckLogEvent = "Area 1 Chime Mode"
		Case 1259: CheckLogEvent = "Area 1 Chime Alert"
		Case 1267: CheckLogEvent = "Entry Delay, Any Area"
		Case 1268: CheckLogEvent = "Area 1 Entry Delay"
		Case 1276: CheckLogEvent = "Exit Delay, Any Area"
		Case 1277: CheckLogEvent = "Area 1 Exit Delay"
		Case 1285: CheckLogEvent = "Area 1 Exit Delay Ends"
		Case 1293: CheckLogEvent = "Automatic Closing"
		Case 1294: CheckLogEvent = "Early Closing"
		Case 1295: CheckLogEvent = "Closing Time Extended"
		Case 1296: CheckLogEvent = "Fail to Close"
		Case 1297: CheckLogEvent = "Late to Close"
		Case 1298: CheckLogEvent = "Keyswitch Closing"
		Case 1299: CheckLogEvent = "Duress"
		Case 1300: CheckLogEvent = "Exeption Opening"
		Case 1301: CheckLogEvent = "Early Opening"
		Case 1302: CheckLogEvent = "Fail to Open"
		Case 1303: CheckLogEvent = "Late to Open"
		Case 1304: CheckLogEvent = "Keyswitch Opening"
		Case 1305: CheckLogEvent = "Area 1 Closing Ring Back"
		Case 1313: CheckLogEvent = "Access Keypad 01"
		Case 1314: CheckLogEvent = "Access Keypad 02"
		Case 1329: CheckLogEvent = "Access Any Keypad"
		Case 1330: CheckLogEvent = "Beep Area 1 Keypad(s)"
		Case 1338: CheckLogEvent = "Area 1 Exit Error"
		Case 1346: CheckLogEvent = "Audio Amplifier Status"
		Case 1347: CheckLogEvent = "Control Power Status"
		Case 1348: CheckLogEvent = "Light"
		Case 1349: CheckLogEvent = "Dark"
		Case 1350: CheckLogEvent = "Security (Day) Alert"
		Case 1351: CheckLogEvent = "Dialer Abort"
		Case 1352: CheckLogEvent = "Dialer Cancel"
		Case 1353: CheckLogEvent = "Dialer Auto Test"
		Case 1354: CheckLogEvent = "Local Programming"
		Case 1355: CheckLogEvent = "Local Programming Ends"
		Case 1356: CheckLogEvent = "Keyswitch Zone Tamper Alert"
		Case 1357: CheckLogEvent = "Event Log, 80% Full"
		Case 1358: CheckLogEvent = "Telephone Line is Ringing"
		Case 1359: CheckLogEvent = "Telephone Line Seize"
		Case 1360: CheckLogEvent = "Telephone Line Off/On Hook"
		Case 1361: CheckLogEvent = "Telephone Local Access"
		Case 1362: CheckLogEvent = "Telephone Remote Access"
		Case 1363: CheckLogEvent = "Remote Programming"
		Case 1364: CheckLogEvent = "Remote Programming Ends"
		Case 1365: CheckLogEvent = "AC Fail TBL - Power Supervisory Zone"
		Case 1366: CheckLogEvent = "Low Battery TBL - Power Supervisory Zone"
		Case 1367: CheckLogEvent = "System Start Up"
		Case 1368: CheckLogEvent = "Control Low Voltage Shutdwon"
		Case 1377: CheckLogEvent = "Lost Serial Port Expander Trouble"
		Case 1378: CheckLogEvent = "Rule Triggered Voice Telephone Dial"
		Case 1379: CheckLogEvent = "Dialer Report Cleared"
		Case 1380: CheckLogEvent = "Central Station Kissoff"
		Case 1381: CheckLogEvent = "Transmitter Supervision Loss"
		Case 1382: CheckLogEvent = "2-Wire Smoke Detector Clean Trouble"
		Case 1383: CheckLogEvent = "Ethernet Trouble"
		Case 1384: CheckLogEvent = "Ethernet Restore"
		Case 1385: CheckLogEvent = "Restore Remote AC Power"
		Case 1386: CheckLogEvent = "Restore Remote Battery"
		Case Else: CheckLogEvent = EventNr
	End Select
End Function


'-------------------------------------------------------
'- Get Text Descriptions from ELK to PC for logging etc
'-------------------------------------------------------
Sub SetStartData(StartDataCount)
	Select Case StartDataCount
		Case 1 : Call RequestTextDescription("02001") 		     'User Name 1
		Case 2 : Call RequestTextDescription("02002") 		     'User Name 2
		Case 3 : Call RequestTextDescription("02003") 		     'User Name 3 
		Case 4 : Call RequestTextDescription("02004") 		     'User Name 4
		Case 5 : Call RequestTextDescription("02005") 		     'User Name 5
		Case 6 : Call RequestTextDescription("02006") 		     'User Name 6
		Case 7 : Call RequestTextDescription("00" & arrZoneNrs(0))   'Zone Name 1 'Below are not physical zone numbers. See array for real numbers
		Case 8 : Call RequestTextDescription("00" & arrZoneNrs(1))   'Zone Name 2
		Case 9 : Call RequestTextDescription("00" & arrZoneNrs(2))   'Zone Name 3
		Case 10: Call RequestTextDescription("00" & arrZoneNrs(3))   'Zone Name 4
		Case 11: Call RequestTextDescription("00" & arrZoneNrs(4))   'Zone Name 5
		Case 12: Call RequestTextDescription("00" & arrZoneNrs(5))   'Zone Name 6
		Case 13: Call RequestTextDescription("00" & arrZoneNrs(6))   'Zone Name 7
		Case 14: Call RequestTextDescription("00" & arrZoneNrs(7))   'Zone Name 8
		Case 15: Call RequestTextDescription("04" & arrOutputNrs(0)) 'Output Name 1
		Case 16: Call RequestTextDescription("04" & arrOutputNrs(1)) 'Output Name 2
		Case 17: Call RequestTextDescription("04" & arrOutputNrs(2)) 'Output Name 3
		Case 18: Call RequestTextDescription("04" & arrOutputNrs(3)) 'Output Name 4
		Case 19: Call RequestTextDescription("03001") 		     'Keypad Name 1
		Case 20: Call RequestTextDescription("03002") 		     'keypad Name 2
		Case 21: Call RequestStatus("Arming")         		     'Arming Status
		Case 22: Call RequestStatus("Zone")           		     'Zone Status
		Case 23: Call RequestStatus("Temperatures")   		     'Keypad en Probe (Zone Sensors) Temperatures
		Case 24: Call RequestStatus("ControlOutput")                 'Output Status
		'Adjust Const MaxStartDataCount to the highest Case Nr!!!
	End Select
End Sub


'-------------------------------------------------------
'- HouseBot / Alarm related Functions ------------------
'-------------------------------------------------------
'- Handle User Specifics after Disarming ---------------
'-------------------------------------------------------
Sub Integration_Arming(Area, ArmedStatus)
Dim strLog
Dim EMailCount
Dim VMailCount
Dim AgendaCount
Dim KeypadText

	EMailCount  = 0
	VMailCount  = 0
	AgendaCount = 0

	If Area = 1 Then	
		Select Case ArmedStatus
			Case "Disarmed":
				 'ALLE IO_KAST DISARM ZAKEN MOETEN HIER (Lampen, EMail check -> voordat onderstaande counters worden uitgelezen)
				 ' Wel per user zodat Richard en Angela wel lampen bedienen en pa + ma en de rest niet.
				If LastUserCode <= MaxUsers Then
					Select Case LastUserCode
						Case 1   : EMailCount  = GetPropertyValue ("EMail.Account0 Total")
							   VMailCount  = GetPropertyValue ("Telefoon Status.VoiceMail Count")
							   AgendaCount = GetPropertyValue ("Agenda.Event Count")
							   KeypadText  = "Hallo Richard^" & "EM:" & EMailCount & " VM:" & VMailCount & " AG:" & AgendaCount
							   If LastKeypadNr = 1 Then
							   	SpeakWord("EMail " & CStr(EMailCount) & " VMail " & CStr(VMailCount) & " Agenda " & CStr(AgendaCount))
							   End If
						Case 2   : EMailCount  = GetPropertyValue ("EMail.Account3 Total")
							   VMailCount  = GetPropertyValue ("Telefoon Status.VoiceMail Count")
							   AgendaCount = GetPropertyValue ("Agenda.Event Count")
							   KeypadText  = "Hallo Angela^" & "EM:" & EMailCount & " VM:" & VMailCount & " AG:" & AgendaCount
							   If LastKeypadNr = 1 Then
							   	SpeakWord("EMail " & CStr(EMailCount) & " VMail " & CStr(VMailCount) & " Agenda " & CStr(AgendaCount))
							   End If
						Case 3   : KeypadText  = "Hallo Corry"
						Case 4   : KeypadText  = "Hallo Pa en Ma"
						Case Else: KeypadText  = ""
					End Select
        	        		
					If KeypadText <> "" Then
						Call DisplayText("12100020" & KeypadText) 'Text will be displayed with a 20 second timeout
					End If
				End If
			Case "Armed Away":		'ALLE IO_KAST ARM ZAKEN MOETEN HIERONDER (Alle AV en lampen uit etc)
			Case "Armed Stay":		'Future use (???)
			Case "Armed Stay Instant":	'Not used
			Case "Armed Night":		'Plasma en beamer uit, Keypad text Welterusten User
			Case "Armed Night Instant":	'Not used
			Case "Armed Vacation":		'Vakantie State aanzetten
		End Select
	End If
End Sub


'-------------------------------------------------------
'- Handle Keypad Presses for Integration ---------------
'-------------------------------------------------------
Sub Integration_Keys(KeypadNr, KeypadKey)
Dim EMailCount
Dim VMailCount
Dim AgendaCount
Dim KeypadText

	EMailCount  = 0
	VMailCount  = 0
	AgendaCount = 0

	Select Case KeypadKey
		Case "F4": SetPropertyValue "IO_Kast.Garage", "Pulse"
			   Call DisplayText("12100020" & "Garagedeur")
		Case "F5": 'Power On Receiver @ Radio538
			   Call DisplayText("12100020" & "Radio 538")
		Case "F6": EMailCount  = GetPropertyValue ("EMail.Accounts Total")
			   VMailCount  = GetPropertyValue ("Telefoon Status.VoiceMail Count")
			   AgendaCount = GetPropertyValue ("Agenda.Event Count")
			   KeypadText =  "EM:" & EMailCount & " VM:" & VMailCount & " AG:" & AgendaCount
			   Call DisplayText("12100020" & KeypadText)
			   If KeypadNr = 1 Then
			   	SpeakWord("EMail " & CStr(EMailCount) & " VMail " & CStr(VMailCount) & " Agenda " & CStr(AgendaCount))
			   End If
	End Select

End Sub


'-------------------------------------------------------
'- Commonly used Subs and Functions for Integration ---- 
'-------------------------------------------------------

'Speak Words / Phrases @ certain events other than alarm specific
'LogLines which combine tripped zones and alarm states